function reload(unload)
	--Without an argument this just reloads all plugins
	--With an argument it loads all plugins EXCEPT the argument!
	--Verbose without an argument.
	
	Turbine.Shell.WriteLine("***")
	if unload==nil then
		Turbine.Shell.WriteLine("Reload started")
	else
		Turbine.Shell.WriteLine("Reloading all plugins, except "..unload)
	end
	
	Turbine.Shell.WriteLine("***")
	
	local Plugins=Turbine.PluginManager.GetLoadedPlugins()

	for k,v in pairs(Plugins) do
		if v.ScriptState~="Reloader" then
			Turbine.PluginManager.UnloadScriptState(v.ScriptState)
		end
	end

	for k,v in pairs(Plugins) do
		if v.ScriptState~="Reloader" then
			--Look to see if this plugin is to be unloaded.
			--This uses a string.upper to allow easier access to slash commands to unload a plugin.
			local t=false
			if unload~=nil then t=(string.upper(unload)==string.upper(v.Name)) end
			if t==false then
				if unload==nil then Turbine.Shell.WriteLine("Loading "..v.Name) end
				Turbine.PluginManager.LoadPlugin(v.Name)
			end
		end
	end
	Turbine.Shell.WriteLine("***")
	Turbine.Shell.WriteLine("Reload finished")
	Turbine.Shell.WriteLine("***")
end

--Show the Button (Or Hide it)
function ShowButton()

	--Hide it?
	if ButtonShown==false then
		if Button~=nil then Button.Window:SetVisible(false) end
		return
	end	

	--Default data
	if ButtonData==nil then
		ButtonData={}
		ButtonData.X=100
		ButtonData.Y=100
		ButtonData.Scale=1
	end
		
	--Thanks Deus!
	import "Deusdictum.UI.Dragbar"
	
	Button={}
		Button.Window=Turbine.UI.Window()
		Button.Window:SetVisible(true)
		Button.Window.DragBar = Deusdictum.UI.DragBar( Button.Window,"Loader")
		Button.Window:SetPosition(ButtonData.X,ButtonData.Y)
		Button.Window:SetSize(32,32)
		Button.Window:SetOpacity(1)
		Button.Window:SetMouseVisible(true)
		Button.Window:SetBackground("JackdawPlugins/Reloader/reload.tga")
		Button.Window:SetStretchMode(1)
		Button.Window:SetSize(32*ButtonData.Scale,32*ButtonData.Scale)
			
		function Button.Window:GetWidth()
			return 32*ButtonData.Scale
		end
		function Button.Window:GetHeight()
			return 32*ButtonData.Scale
		end
		function Button.Window:GetSize()
			return 32*ButtonData.Scale ,32*ButtonData.Scale
		end
		
		Button.Window.DragBar:Refresh()
			
		Button.Window.DragEnd=function ()
			ButtonData.X,ButtonData.Y=Button.Window:GetPosition()
		end
		
		Button.Window.MouseDown=function(sender,args)
			if Button.Window.DragBar:IsVisible() then
				moving=true
			else
				if ( args.Button == Turbine.UI.MouseButton.Left ) then
			
					local contextMenu = Turbine.UI.ContextMenu()
					contextMenu.items = contextMenu:GetItems()

					local option1 = Turbine.UI.MenuItem("Reload Plugins", true)
					option1.Click = function () reload() end

					local option2 = Turbine.UI.MenuItem("Hide Button", true)
					option2.Click = function () Button.Window:SetVisible(false) ButtonShown=false end

					--Now the serious one; list all plugins, with their loaded state ticked. Then allow clickage.
					local option3 = Turbine.UI.MenuItem("Load/Unload Plugin;")
						contextMenu.SubMenuItems = option3:GetItems()
							--Refresh list
							Turbine.PluginManager.RefreshAvailablePlugins()
							
							--Create a list to hold all this
							local list={}
							
							--List of loaded plugins
							local LoadedPlugins=Turbine.PluginManager.GetLoadedPlugins()
						
							--List of available plugins
							local AvailablePlugin=
							Turbine.PluginManager.GetAvailablePlugins()
						
							for k,v in pairs(AvailablePlugin) do
								list[v.Name]={}
							end
							
							for k,v in pairs(LoadedPlugins) do
								list[v.Name].Loaded=true
							end
							
							--Use the list to build the button options.
							
							for v in orderedPairs(list) do
								if v~="Reloader" then
									list[v].option=Turbine.UI.MenuItem(v,true,list[v].Loaded)
									contextMenu.SubMenuItems:Add(list[v].option)
									list[v].option.Click = function ()
										if list[v].Loaded then
											reload(v)
										else
											Turbine.PluginManager.LoadPlugin(v)
										end
									end
								end
							end

					contextMenu.items:Add(option1)
					contextMenu.items:Add(option2)
					contextMenu.items:Add(option3)
					
					contextMenu:ShowMenu()
				end
			end	
		end
		
		Button.Window.MouseUp=function(sender,args)
			moving=false
		end
		
		Button.Window.MouseMove=function(sender,args)
				if moving then
				local x,y=Button.Window:GetMousePosition()

				ButtonData.Scale=math.max(x,y)/32
				if ButtonData.Scale<0.25 then ButtonData.Scale=0.25 end

				Button.Window:SetSize(32*ButtonData.Scale,32*ButtonData.Scale)
				Button.Window.DragBar:Refresh()
			end
		end
	
		--Now, for a little fun. Spinning button!
		Button.Window.MouseEnter=function(sender,args)
			Button.Window:SetWantsUpdates(true)
		end

		Button.Window.MouseLeave=function(sender,args)
			Button.Window:SetWantsUpdates(false)
		end

		ang=0
		function Button.Window:Update()
			ang=ang-5
			Button.Window:SetRotation({x=0,y=0,z=ang});
		end
	
end
		
--Ordered pair functions from http://lua-users.org/wiki/SortedIteration
function __genOrderedIndex( t )
    local orderedIndex = {}
    for key in pairs(t) do
        table.insert( orderedIndex, key )
    end
    table.sort( orderedIndex )
    return orderedIndex
end

function orderedNext(t, state)
    -- Equivalent of the next function, but returns the keys in the alphabetic
    -- order. We use a temporary ordered key table that is stored in the
    -- table being iterated.

    --print("orderedNext: state = "..tostring(state) )
    if state == nil then
        -- the first time, generate the index
        t.__orderedIndex = __genOrderedIndex( t )
        key = t.__orderedIndex[1]
        return key, t[key]
    end
    -- fetch the next value
    key = nil
    for i = 1,table.getn(t.__orderedIndex) do
        if t.__orderedIndex[i] == state then
            key = t.__orderedIndex[i+1]
        end
    end

    if key then
        return key, t[key]
    end

    -- no more value to return, cleanup
    t.__orderedIndex = nil
    return
end

function orderedPairs(t)
    -- Equivalent of the pairs() function on tables. Allows to iterate
    -- in order
    return orderedNext, t, nil
end	